/*
	RT Bench - Benchmarks various hash functions for Rainbow Tables
	Copyright (C) 2012 Steve Thomas <steve AT tobtu DOT com>

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef CISCO_HELP_H
#define CISCO_HELP_H

#define FINISH_CISCO(hash,i) \
	((__m128i*) hash)[0 * __MD5_INTERLACED__ + i] = _mm_or_si128(_mm_and_si128(               ((__m128i*) hash)[0 * __MD5_INTERLACED__ + i]     , _mm_set1_epi32(0x00ffffff)), _mm_slli_epi32(((__m128i*) hash)[1 * __MD5_INTERLACED__ + i], 24)); \
	((__m128i*) hash)[1 * __MD5_INTERLACED__ + i] = _mm_or_si128(_mm_and_si128(_mm_srli_epi32(((__m128i*) hash)[1 * __MD5_INTERLACED__ + i],  8), _mm_set1_epi32(0x0000ffff)), _mm_slli_epi32(((__m128i*) hash)[2 * __MD5_INTERLACED__ + i], 16)); \
	((__m128i*) hash)[2 * __MD5_INTERLACED__ + i] = _mm_or_si128(_mm_and_si128(_mm_srli_epi32(((__m128i*) hash)[2 * __MD5_INTERLACED__ + i], 16), _mm_set1_epi32(0x000000ff)), _mm_slli_epi32(((__m128i*) hash)[3 * __MD5_INTERLACED__ + i],  8));

#endif
